/* Start Header */

/* File:         ICGlueCFM.c
 * Generated by: 1.0d6
 * For:          IC 2.0
 * On:           Wednesday, 24 December 1997, 8:29:16
 * 
 * This file is part of the Internet Configuration system and
 * is placed in the public domain for the benefit of all.
 */

/* End Header */

#include <Types.h>
#include <MixedMode.h>
#include <Components.h>

#include "InternetConfig.h"

#pragma options align=mac68k

enum {
  uppCallComponentProcInfo = kPascalStackBased
    | RESULT_SIZE(kFourByteCode)
    | STACK_ROUTINE_PARAMETER(1, kFourByteCode)
};

pascal ICError ICStart(ICInstance *inst, OSType creator)
{
  ICError junk;
  ICError err;
  long response;
  struct {
    char param_flags;
    char param_size;
    short param_what;
    OSType creator;
    ICInstance inst;
  } params;
  
  *inst = nil;
  if (Gestalt(gestaltComponentMgr, &response) == noErr) {
    *inst = (ICInstance) OpenDefaultComponent(kICComponentType, kICComponentSubType);
  }
  if (*inst == nil) {
    err = badComponentInstance;
  } else {
    params.param_flags = 0;
    params.param_size = 4;
    params.param_what = 0x00;
    params.creator = creator;
    params.inst = *inst;
    err = CallUniversalProc(CallComponentUPP, uppCallComponentProcInfo, &params);
    if (err != noErr) {
      junk = CloseComponent((ComponentInstance) *inst);
      *inst = nil;
    }
  }
  return err;
}

pascal ICError ICCStart(ComponentInstance *inst, OSType creator)
{
	return ICStart((ICInstance *)inst, creator);
}

pascal ICError ICStop(ICInstance inst)
{
  ICError err;
  ICError err2;
  struct {
    char param_flags;
    char param_size;
    short param_what;
    ICInstance inst;
  } params;
  
  params.param_flags = 0;
  params.param_size = 0;
  params.param_what = 0x01;
  params.inst = inst;
  err = CallUniversalProc(CallComponentUPP, uppCallComponentProcInfo, &params);
  err2 = CloseComponent((ComponentInstance) inst);
  if (err == noErr) {
    err = err2;
  }
  return err;
}

pascal ICError ICCStop(ComponentInstance inst)
{
	return ICStop((ICInstance)inst);
}

pascal ICError ICGetComponentInstance(ICInstance inst, ComponentInstance *componentInst)
{
	*componentInst = (ComponentInstance) inst;
	if (inst == nil) {
		return badComponentInstance;
	} else {
		return noErr;
	}
}

pascal ICError ICCGetComponentInstance(ComponentInstance inst, ComponentInstance *componentInst)
{
	*componentInst = inst;
	if (inst == nil) {
		return badComponentInstance;
	} else {
		return noErr;
	}
}

/* Start ICGlueCFM.c */

/* ***** Starting Up and Shutting Down ***** */

/* ***** Specifying a Configuration ***** */

pascal ICError ICFindConfigFile(ICInstance inst, short count, ICDirSpecArrayPtr folders)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICDirSpecArrayPtr folders;
	short count;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 6;
  p.pWhat = 2;
  p.folders = folders;
  p.count = count;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCFindConfigFile(ComponentInstance inst, short count, ICDirSpecArrayPtr folders)
{
  return ICFindConfigFile((ICInstance)inst, count, folders);
}

pascal ICError ICFindUserConfigFile(ICInstance inst, ICDirSpec *where)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICDirSpec *where;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 14;
  p.where = where;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCFindUserConfigFile(ComponentInstance inst, ICDirSpec *where)
{
  return ICFindUserConfigFile((ICInstance)inst, where);
}

pascal ICError ICGeneralFindConfigFile(ICInstance inst, Boolean searchPrefs, Boolean canCreate, short count, ICDirSpecArrayPtr folders)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICDirSpecArrayPtr folders;
	short count;
	Boolean canCreate;
	char filler1;
	Boolean searchPrefs;
	char filler0;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 10;
  p.pWhat = 30;
  p.folders = folders;
  p.count = count;
  p.canCreate = canCreate;
  p.searchPrefs = searchPrefs;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGeneralFindConfigFile(ComponentInstance inst, Boolean searchPrefs, Boolean canCreate, short count, ICDirSpecArrayPtr folders)
{
  return ICGeneralFindConfigFile((ICInstance)inst, searchPrefs, canCreate, count, folders);
}

pascal ICError ICChooseConfig(ICInstance inst)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	/* nothing to declare */
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 0;
  p.pWhat = 33;
  /* nothing to do */
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCChooseConfig(ComponentInstance inst)
{
  return ICChooseConfig((ICInstance)inst);
}

pascal ICError ICChooseNewConfig(ICInstance inst)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	/* nothing to declare */
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 0;
  p.pWhat = 34;
  /* nothing to do */
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCChooseNewConfig(ComponentInstance inst)
{
  return ICChooseNewConfig((ICInstance)inst);
}

pascal ICError ICGetConfigName(ICInstance inst, Boolean longname, Str255 name)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	StringPtr name;
	Boolean longname;
	char filler0;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 6;
  p.pWhat = 35;
  p.name = name;
  p.longname = longname;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetConfigName(ComponentInstance inst, Boolean longname, Str255 name)
{
  return ICGetConfigName((ICInstance)inst, longname, name);
}

pascal ICError ICGetConfigReference(ICInstance inst, ICConfigRefHandle ref)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICConfigRefHandle ref;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 31;
  p.ref = ref;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetConfigReference(ComponentInstance inst, ICConfigRefHandle ref)
{
  return ICGetConfigReference((ICInstance)inst, ref);
}

pascal ICError ICSetConfigReference(ICInstance inst, ICConfigRefHandle ref, long flags)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	long flags;
	ICConfigRefHandle ref;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 8;
  p.pWhat = 32;
  p.flags = flags;
  p.ref = ref;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCSetConfigReference(ComponentInstance inst, ICConfigRefHandle ref, long flags)
{
  return ICSetConfigReference((ICInstance)inst, ref, flags);
}

/* ***** Private Routines *****
 * 
 * If you are calling these routines, you are most probably doing something
 * wrong.  Please read the documentation for more details.
 */

pascal ICError ICSpecifyConfigFile(ICInstance inst, FSSpec *config)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	FSSpec *config;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 3;
  p.config = config;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCSpecifyConfigFile(ComponentInstance inst, FSSpec *config)
{
  return ICSpecifyConfigFile((ICInstance)inst, config);
}

pascal ICError ICRefreshCaches(ICInstance inst)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	/* nothing to declare */
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 0;
  p.pWhat = 47;
  /* nothing to do */
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCRefreshCaches(ComponentInstance inst)
{
  return ICRefreshCaches((ICInstance)inst);
}

/* ***** Getting Information ***** */

pascal ICError ICGetSeed(ICInstance inst, long *seed)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	long *seed;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 4;
  p.seed = seed;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetSeed(ComponentInstance inst, long *seed)
{
  return ICGetSeed((ICInstance)inst, seed);
}

pascal ICError ICGetPerm(ICInstance inst, ICPerm *perm)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICPerm *perm;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 13;
  p.perm = perm;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetPerm(ComponentInstance inst, ICPerm *perm)
{
  return ICGetPerm((ICInstance)inst, perm);
}

pascal ICError ICDefaultFileName(ICInstance inst, Str63 name)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	StringPtr name;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 11;
  p.name = name;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCDefaultFileName(ComponentInstance inst, Str63 name)
{
  return ICDefaultFileName((ICInstance)inst, name);
}

/* ***** Reading and Writing Preferences ***** */

pascal ICError ICBegin(ICInstance inst, ICPerm perm)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICPerm perm;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 2;
  p.pWhat = 5;
  p.perm = perm;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCBegin(ComponentInstance inst, ICPerm perm)
{
  return ICBegin((ICInstance)inst, perm);
}

pascal ICError ICGetPref(ICInstance inst, ConstStr255Param key, ICAttr *attr, Ptr buf, long *size)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	long *size;
	Ptr buf;
	ICAttr *attr;
	StringPtr key;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 16;
  p.pWhat = 6;
  p.size = size;
  p.buf = buf;
  p.attr = attr;
  p.key = (StringPtr) key;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetPref(ComponentInstance inst, ConstStr255Param key, ICAttr *attr, Ptr buf, long *size)
{
  return ICGetPref((ICInstance)inst, key, attr, buf, size);
}

pascal ICError ICSetPref(ICInstance inst, ConstStr255Param key, ICAttr attr, Ptr buf, long size)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	long size;
	Ptr buf;
	ICAttr attr;
	StringPtr key;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 16;
  p.pWhat = 7;
  p.size = size;
  p.buf = buf;
  p.attr = attr;
  p.key = (StringPtr) key;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCSetPref(ComponentInstance inst, ConstStr255Param key, ICAttr attr, Ptr buf, long size)
{
  return ICSetPref((ICInstance)inst, key, attr, buf, size);
}

pascal ICError ICFindPrefHandle(ICInstance inst, ConstStr255Param key, ICAttr *attr, Handle prefh)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	Handle prefh;
	ICAttr *attr;
	StringPtr key;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 12;
  p.pWhat = 36;
  p.prefh = prefh;
  p.attr = attr;
  p.key = (StringPtr) key;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCFindPrefHandle(ComponentInstance inst, ConstStr255Param key, ICAttr *attr, Handle prefh)
{
  return ICFindPrefHandle((ICInstance)inst, key, attr, prefh);
}

pascal ICError ICGetPrefHandle(ICInstance inst, ConstStr255Param key, ICAttr *attr, Handle *prefh)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	Handle *prefh;
	ICAttr *attr;
	StringPtr key;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 12;
  p.pWhat = 26;
  p.prefh = prefh;
  p.attr = attr;
  p.key = (StringPtr) key;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetPrefHandle(ComponentInstance inst, ConstStr255Param key, ICAttr *attr, Handle *prefh)
{
  return ICGetPrefHandle((ICInstance)inst, key, attr, prefh);
}

pascal ICError ICSetPrefHandle(ICInstance inst, ConstStr255Param key, ICAttr attr, Handle prefh)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	Handle prefh;
	ICAttr attr;
	StringPtr key;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 12;
  p.pWhat = 27;
  p.prefh = prefh;
  p.attr = attr;
  p.key = (StringPtr) key;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCSetPrefHandle(ComponentInstance inst, ConstStr255Param key, ICAttr attr, Handle prefh)
{
  return ICSetPrefHandle((ICInstance)inst, key, attr, prefh);
}

pascal ICError ICCountPref(ICInstance inst, long *count)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	long *count;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 8;
  p.count = count;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCCountPref(ComponentInstance inst, long *count)
{
  return ICCountPref((ICInstance)inst, count);
}

pascal ICError ICGetIndPref(ICInstance inst, long index, Str255 key)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	StringPtr key;
	long index;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 8;
  p.pWhat = 9;
  p.key = key;
  p.index = index;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetIndPref(ComponentInstance inst, long index, Str255 key)
{
  return ICGetIndPref((ICInstance)inst, index, key);
}

pascal ICError ICDeletePref(ICInstance inst, ConstStr255Param key)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	StringPtr key;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 12;
  p.key = (StringPtr) key;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCDeletePref(ComponentInstance inst, ConstStr255Param key)
{
  return ICDeletePref((ICInstance)inst, key);
}

pascal ICError ICEnd(ICInstance inst)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	/* nothing to declare */
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 0;
  p.pWhat = 10;
  /* nothing to do */
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCEnd(ComponentInstance inst)
{
  return ICEnd((ICInstance)inst);
}

/* ***** User Interface Stuff ***** */

pascal ICError ICEditPreferences(ICInstance inst, ConstStr255Param key)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	StringPtr key;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 15;
  p.key = (StringPtr) key;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCEditPreferences(ComponentInstance inst, ConstStr255Param key)
{
  return ICEditPreferences((ICInstance)inst, key);
}

/* ***** URL Handling ***** */

pascal ICError ICParseURL(ICInstance inst, ConstStr255Param hint, Ptr data, long len, long *selStart, long *selEnd, Handle url)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	Handle url;
	long *selEnd;
	long *selStart;
	long len;
	Ptr data;
	StringPtr hint;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 24;
  p.pWhat = 16;
  p.url = url;
  p.selEnd = selEnd;
  p.selStart = selStart;
  p.len = len;
  p.data = data;
  p.hint = (StringPtr) hint;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCParseURL(ComponentInstance inst, ConstStr255Param hint, Ptr data, long len, long *selStart, long *selEnd, Handle url)
{
  return ICParseURL((ICInstance)inst, hint, data, len, selStart, selEnd, url);
}

pascal ICError ICLaunchURL(ICInstance inst, ConstStr255Param hint, Ptr data, long len, long *selStart, long *selEnd)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	long *selEnd;
	long *selStart;
	long len;
	Ptr data;
	StringPtr hint;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 20;
  p.pWhat = 17;
  p.selEnd = selEnd;
  p.selStart = selStart;
  p.len = len;
  p.data = data;
  p.hint = (StringPtr) hint;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCLaunchURL(ComponentInstance inst, ConstStr255Param hint, Ptr data, long len, long *selStart, long *selEnd)
{
  return ICLaunchURL((ICInstance)inst, hint, data, len, selStart, selEnd);
}

/* ***** Mappings Routines *****
 * 
 * Routines for interrogating mappings database.
 * 
 * ----- High Level Routines -----
 */

pascal ICError ICMapFilename(ICInstance inst, ConstStr255Param filename, ICMapEntry *entry)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICMapEntry *entry;
	StringPtr filename;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 8;
  p.pWhat = 24;
  p.entry = entry;
  p.filename = (StringPtr) filename;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCMapFilename(ComponentInstance inst, ConstStr255Param filename, ICMapEntry *entry)
{
  return ICMapFilename((ICInstance)inst, filename, entry);
}

pascal ICError ICMapTypeCreator(ICInstance inst, OSType fType, OSType fCreator, ConstStr255Param filename, ICMapEntry *entry)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICMapEntry *entry;
	StringPtr filename;
	OSType fCreator;
	OSType fType;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 16;
  p.pWhat = 25;
  p.entry = entry;
  p.filename = (StringPtr) filename;
  p.fCreator = fCreator;
  p.fType = fType;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCMapTypeCreator(ComponentInstance inst, OSType fType, OSType fCreator, ConstStr255Param filename, ICMapEntry *entry)
{
  return ICMapTypeCreator((ICInstance)inst, fType, fCreator, filename, entry);
}

/* ----- Mid Level Routines ----- */

pascal ICError ICMapEntriesFilename(ICInstance inst, Handle entries, ConstStr255Param filename, ICMapEntry *entry)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICMapEntry *entry;
	StringPtr filename;
	Handle entries;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 12;
  p.pWhat = 28;
  p.entry = entry;
  p.filename = (StringPtr) filename;
  p.entries = entries;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCMapEntriesFilename(ComponentInstance inst, Handle entries, ConstStr255Param filename, ICMapEntry *entry)
{
  return ICMapEntriesFilename((ICInstance)inst, entries, filename, entry);
}

pascal ICError ICMapEntriesTypeCreator(ICInstance inst, Handle entries, OSType fType, OSType fCreator, ConstStr255Param filename, ICMapEntry *entry)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICMapEntry *entry;
	StringPtr filename;
	OSType fCreator;
	OSType fType;
	Handle entries;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 20;
  p.pWhat = 29;
  p.entry = entry;
  p.filename = (StringPtr) filename;
  p.fCreator = fCreator;
  p.fType = fType;
  p.entries = entries;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCMapEntriesTypeCreator(ComponentInstance inst, Handle entries, OSType fType, OSType fCreator, ConstStr255Param filename, ICMapEntry *entry)
{
  return ICMapEntriesTypeCreator((ICInstance)inst, entries, fType, fCreator, filename, entry);
}

/* ----- Low Level Routines ----- */

pascal ICError ICCountMapEntries(ICInstance inst, Handle entries, long *count)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	long *count;
	Handle entries;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 8;
  p.pWhat = 18;
  p.count = count;
  p.entries = entries;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCCountMapEntries(ComponentInstance inst, Handle entries, long *count)
{
  return ICCountMapEntries((ICInstance)inst, entries, count);
}

pascal ICError ICGetIndMapEntry(ICInstance inst, Handle entries, long index, long *pos, ICMapEntry *entry)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICMapEntry *entry;
	long *pos;
	long index;
	Handle entries;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 16;
  p.pWhat = 19;
  p.entry = entry;
  p.pos = pos;
  p.index = index;
  p.entries = entries;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetIndMapEntry(ComponentInstance inst, Handle entries, long index, long *pos, ICMapEntry *entry)
{
  return ICGetIndMapEntry((ICInstance)inst, entries, index, pos, entry);
}

pascal ICError ICGetMapEntry(ICInstance inst, Handle entries, long pos, ICMapEntry *entry)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICMapEntry *entry;
	long pos;
	Handle entries;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 12;
  p.pWhat = 20;
  p.entry = entry;
  p.pos = pos;
  p.entries = entries;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetMapEntry(ComponentInstance inst, Handle entries, long pos, ICMapEntry *entry)
{
  return ICGetMapEntry((ICInstance)inst, entries, pos, entry);
}

pascal ICError ICSetMapEntry(ICInstance inst, Handle entries, long pos, ICMapEntry *entry)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICMapEntry *entry;
	long pos;
	Handle entries;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 12;
  p.pWhat = 21;
  p.entry = entry;
  p.pos = pos;
  p.entries = entries;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCSetMapEntry(ComponentInstance inst, Handle entries, long pos, ICMapEntry *entry)
{
  return ICSetMapEntry((ICInstance)inst, entries, pos, entry);
}

pascal ICError ICDeleteMapEntry(ICInstance inst, Handle entries, long pos)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	long pos;
	Handle entries;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 8;
  p.pWhat = 22;
  p.pos = pos;
  p.entries = entries;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCDeleteMapEntry(ComponentInstance inst, Handle entries, long pos)
{
  return ICDeleteMapEntry((ICInstance)inst, entries, pos);
}

pascal ICError ICAddMapEntry(ICInstance inst, Handle entries, ICMapEntry *entry)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICMapEntry *entry;
	Handle entries;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 8;
  p.pWhat = 23;
  p.entry = entry;
  p.entries = entries;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCAddMapEntry(ComponentInstance inst, Handle entries, ICMapEntry *entry)
{
  return ICAddMapEntry((ICInstance)inst, entries, entry);
}

/* ***** Profile Management Routines ***** */

pascal ICError ICGetCurrentProfile(ICInstance inst, ICProfileID *currentID)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICProfileID *currentID;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 37;
  p.currentID = currentID;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetCurrentProfile(ComponentInstance inst, ICProfileID *currentID)
{
  return ICGetCurrentProfile((ICInstance)inst, currentID);
}

pascal ICError ICSetCurrentProfile(ICInstance inst, ICProfileID newID)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICProfileID newID;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 38;
  p.newID = newID;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCSetCurrentProfile(ComponentInstance inst, ICProfileID newID)
{
  return ICSetCurrentProfile((ICInstance)inst, newID);
}

pascal ICError ICCountProfiles(ICInstance inst, long *count)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	long *count;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 39;
  p.count = count;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCCountProfiles(ComponentInstance inst, long *count)
{
  return ICCountProfiles((ICInstance)inst, count);
}

pascal ICError ICGetIndProfile(ICInstance inst, long index, ICProfileID *thisID)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICProfileID *thisID;
	long index;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 8;
  p.pWhat = 40;
  p.thisID = thisID;
  p.index = index;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetIndProfile(ComponentInstance inst, long index, ICProfileID *thisID)
{
  return ICGetIndProfile((ICInstance)inst, index, thisID);
}

pascal ICError ICGetProfileName(ICInstance inst, ICProfileID thisID, Str255 name)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	StringPtr name;
	ICProfileID thisID;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 8;
  p.pWhat = 41;
  p.name = name;
  p.thisID = thisID;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetProfileName(ComponentInstance inst, ICProfileID thisID, Str255 name)
{
  return ICGetProfileName((ICInstance)inst, thisID, name);
}

pascal ICError ICSetProfileName(ICInstance inst, ICProfileID thisID, ConstStr255Param name)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	StringPtr name;
	ICProfileID thisID;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 8;
  p.pWhat = 42;
  p.name = (StringPtr) name;
  p.thisID = thisID;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCSetProfileName(ComponentInstance inst, ICProfileID thisID, ConstStr255Param name)
{
  return ICSetProfileName((ICInstance)inst, thisID, name);
}

pascal ICError ICAddProfile(ICInstance inst, ICProfileID prototypeID, ICProfileID *newID)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICProfileID *newID;
	ICProfileID prototypeID;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 8;
  p.pWhat = 43;
  p.newID = newID;
  p.prototypeID = prototypeID;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCAddProfile(ComponentInstance inst, ICProfileID prototypeID, ICProfileID *newID)
{
  return ICAddProfile((ICInstance)inst, prototypeID, newID);
}

pascal ICError ICDeleteProfile(ICInstance inst, ICProfileID thisID)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	ICProfileID thisID;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 44;
  p.thisID = thisID;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCDeleteProfile(ComponentInstance inst, ICProfileID thisID)
{
  return ICDeleteProfile((ICInstance)inst, thisID);
}

/* ***** Interrupt Safe Routines ***** */

pascal ICError ICRequiresInterruptSafe(ICInstance inst)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	/* nothing to declare */
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 0;
  p.pWhat = 45;
  /* nothing to do */
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCRequiresInterruptSafe(ComponentInstance inst)
{
  return ICRequiresInterruptSafe((ICInstance)inst);
}

pascal ICError ICGetMappingInterruptSafe(ICInstance inst, Ptr *mappingPref, long *mappingPrefSize)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	long *mappingPrefSize;
	Ptr *mappingPref;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 8;
  p.pWhat = 46;
  p.mappingPrefSize = mappingPrefSize;
  p.mappingPref = mappingPref;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetMappingInterruptSafe(ComponentInstance inst, Ptr *mappingPref, long *mappingPrefSize)
{
  return ICGetMappingInterruptSafe((ICInstance)inst, mappingPref, mappingPrefSize);
}

pascal ICError ICGetSeedInterruptSafe(ICInstance inst, long *seed)
{
  struct {
    char pFlags;
    char pSize;
    short pWhat;
	long *seed;
    ICInstance inst;
  } p;
  p.pFlags = 0;
  p.pSize = 4;
  p.pWhat = 48;
  p.seed = seed;
  p.inst = inst;
  return CallUniversalProc(CallComponentUPP,
    uppCallComponentProcInfo,
    &p);
}

pascal ICError ICCGetSeedInterruptSafe(ComponentInstance inst, long *seed)
{
  return ICGetSeedInterruptSafe((ICInstance)inst, seed);
}


/* End ICGlueCFM.c */

/* End of File */
